'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _betType = require('./enums/bet-type');

var _betType2 = _interopRequireDefault(_betType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * An immutable object which represents a bet made by a player during a game.
 * @class Bet
 */
var Bet = function () {

  /**
   * @param {BetTypeValue} $0.type Type of the bet.
   * @param {number} [$0.amount] Amount of the bet.
   */

  /**
   * Type of the bet.
   */
  function Bet(_ref) {
    var type = _ref.type;
    var _ref$amount = _ref.amount;
    var amount = _ref$amount === undefined ? 0 : _ref$amount;
    (0, _classCallCheck3.default)(this, Bet);

    this.type = type;
    this.amount = amount;
  }

  /**
   * Amount of the bet.
   */


  (0, _createClass3.default)(Bet, [{
    key: 'toJSON',
    value: function toJSON() {
      return {
        type: _betType2.default.toString(this.type),
        amount: this.amount
      };
    }
  }]);
  return Bet;
}();

exports.default = Bet;
//# sourceMappingURL=bet.js.map