'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});


/**
 * Represents the state of a game.
 * @enum {number}
 */
var GameState = {
  UNSTARTED: 0,
  GENERATING_INITIAL_DECK: 1,
  SHUFFLING_DECK: 2,
  LOCKING_DECK: 3,
  PLAYING: 4,
  ENDED: 5,

  toString: function toString(value) {
    switch (value) {
      case GameState.GENERATING_INITIAL_DECK:
        return 'generatingInitialDeck';
      case GameState.SHUFFLING_DECK:
        return 'shufflingDeck';
      case GameState.LOCKING_DECK:
        return 'lockingDeck';
      case GameState.PLAYING:
        return 'playing';
      case GameState.ENDED:
        return 'ended';
      default:
        return 'unstarted';
    }
  },
  fromString: function fromString(value) {
    switch (value) {
      case 'generatingInitialDeck':
        return GameState.GENERATING_INITIAL_DECK;
      case 'shufflingDeck':
        return GameState.SHUFFLING_DECK;
      case 'lockingDeck':
        return GameState.LOCKING_DECK;
      case 'playing':
        return GameState.PLAYING;
      case 'ended':
        return GameState.ENDED;
      default:
        return GameState.UNSTARTED;
    }
  }
};

exports.default = GameState;
//# sourceMappingURL=game-state.js.map